#!/usr/sbin/dtrace -s

#pragma D option quiet
#pragma D option bufsize=16m
#pragma D option dynvarsize=16m

BEGIN
{
	printf("malloc_type: DRM_MEM_AGPLISTS:  0x%p\n", &`DRM_MEM_AGPLISTS);
	printf("malloc_type: DRM_MEM_BUFLISTS:  0x%p\n", &`DRM_MEM_BUFLISTS);
	printf("malloc_type: DRM_MEM_BUFS:      0x%p\n", &`DRM_MEM_BUFS);
	printf("malloc_type: DRM_MEM_CMDS:      0x%p\n", &`DRM_MEM_CMDS);
	printf("malloc_type: DRM_MEM_CTXBITMAP: 0x%p\n", &`DRM_MEM_CTXBITMAP);
	printf("malloc_type: DRM_MEM_DMA:       0x%p\n", &`DRM_MEM_DMA);
	printf("malloc_type: DRM_MEM_DRAWABLE:  0x%p\n", &`DRM_MEM_DRAWABLE);
	printf("malloc_type: DRM_MEM_DRIVER:    0x%p\n", &`DRM_MEM_DRIVER);
	printf("malloc_type: DRM_MEM_FILES:     0x%p\n", &`DRM_MEM_FILES);
	printf("malloc_type: DRM_MEM_HASHTAB:   0x%p\n", &`DRM_MEM_HASHTAB);
	printf("malloc_type: DRM_MEM_IOCTLS:    0x%p\n", &`DRM_MEM_IOCTLS);
	printf("malloc_type: DRM_MEM_KMS:       0x%p\n", &`DRM_MEM_KMS);
	printf("malloc_type: DRM_MEM_MAGIC:     0x%p\n", &`DRM_MEM_MAGIC);
	printf("malloc_type: DRM_MEM_MAPPINGS:  0x%p\n", &`DRM_MEM_MAPPINGS);
	printf("malloc_type: DRM_MEM_MAPS:      0x%p\n", &`DRM_MEM_MAPS);
	printf("malloc_type: DRM_MEM_MM:        0x%p\n", &`DRM_MEM_MM);
	printf("malloc_type: DRM_MEM_PAGES:     0x%p\n", &`DRM_MEM_PAGES);
	printf("malloc_type: DRM_MEM_QUEUES:    0x%p\n", &`DRM_MEM_QUEUES);
	printf("malloc_type: DRM_MEM_SAREA:     0x%p\n", &`DRM_MEM_SAREA);
	printf("malloc_type: DRM_MEM_SEGS:      0x%p\n", &`DRM_MEM_SEGS);
	printf("malloc_type: DRM_MEM_SGLISTS:   0x%p\n", &`DRM_MEM_SGLISTS);
	printf("malloc_type: M_DRM_GLOBAL:      0x%p\n", &`M_DRM_GLOBAL);
	/*printf("malloc_type: M_TTM_AGP:         0x%p\n", &`M_TTM_AGP);*/
	printf("malloc_type: M_TTM_BO:          0x%p\n", &`M_TTM_BO);
	printf("malloc_type: M_TTM_OBJ_DEV:     0x%p\n", &`M_TTM_OBJ_DEV);
	printf("malloc_type: M_TTM_OBJ_FILE:    0x%p\n", &`M_TTM_OBJ_FILE);
	printf("malloc_type: M_TTM_OBJ_REF:     0x%p\n", &`M_TTM_OBJ_REF);
	printf("malloc_type: M_TTM_PD:          0x%p\n", &`M_TTM_PD);
	printf("malloc_type: M_TTM_POOLMGR:     0x%p\n", &`M_TTM_POOLMGR);
	printf("malloc_type: M_TTM_RMAN:        0x%p\n", &`M_TTM_RMAN);
	printf("malloc_type: M_TTM_TRANSF_OBJ:  0x%p\n", &`M_TTM_TRANSF_OBJ);
	printf("malloc_type: M_TTM_ZONE:        0x%p\n", &`M_TTM_ZONE);
}

fbt:kernel:malloc:entry
/
args[1] == `DRM_MEM_AGPLISTS ||
args[1] == `DRM_MEM_BUFLISTS ||
args[1] == `DRM_MEM_BUFS ||
args[1] == `DRM_MEM_CMDS ||
args[1] == `DRM_MEM_CTXBITMAP ||
args[1] == `DRM_MEM_DMA ||
args[1] == `DRM_MEM_DRAWABLE ||
args[1] == `DRM_MEM_DRIVER ||
args[1] == `DRM_MEM_DRIVER ||
args[1] == `DRM_MEM_FILES ||
args[1] == `DRM_MEM_HASHTAB ||
args[1] == `DRM_MEM_IOCTLS ||
args[1] == `DRM_MEM_KMS ||
args[1] == `DRM_MEM_KMS ||
args[1] == `DRM_MEM_MAGIC ||
args[1] == `DRM_MEM_MAPPINGS ||
args[1] == `DRM_MEM_MAPS ||
args[1] == `DRM_MEM_MM ||
args[1] == `DRM_MEM_PAGES ||
args[1] == `DRM_MEM_QUEUES ||
args[1] == `DRM_MEM_SAREA ||
args[1] == `DRM_MEM_SEGS ||
args[1] == `DRM_MEM_SGLISTS ||
args[1] == `M_DRM_GLOBAL ||
args[1] == `M_TTM_BO ||
args[1] == `M_TTM_OBJ_DEV ||
args[1] == `M_TTM_OBJ_FILE ||
args[1] == `M_TTM_OBJ_REF ||
args[1] == `M_TTM_PD ||
args[1] == `M_TTM_POOLMGR ||
args[1] == `M_TTM_RMAN ||
args[1] == `M_TTM_TRANSF_OBJ ||
args[1] == `M_TTM_ZONE
/
{
/*args[1] == `M_TTM_AGP ||*/
	self->record_malloc = 1;
	self->malloc_type   = args[1];
}

fbt:kernel:malloc:return
/self->record_malloc == 1/
{
	types[args[1]] = self->malloc_type;

	printf("%lu - MALLOC++ 0x%p type: 0x%p\n", timestamp, args[1], self->malloc_type);
	stack();

	self->record_malloc = 0;
	self->malloc_type   = 0;
}

fbt:kernel:free:entry
/args[0] != NULL && types[args[0]]/
{
	printf("%lu - MALLOC-- 0x%p type: 0x%p\n", timestamp, args[0], args[1]);
	stack();

	types[args[0]] = 0;
}
